var obj = document.getElementById('drawing'); 
var ctx = obj.getContext('2d');

ctx.fillStyle = "white";
ctx.strokeStyle = "white";
var startSpeed = 50;    // Начальная скорость
var startR = 15;        // Начальный радиус
var startX = ctx.canvas.width/2;
var startY = ctx.canvas.height + startR;
var startAngle = 90;    
var kAngle = 0.5;       // Коэффициент изменения угла вылета следующих пузырей
var kChange = 0.7;      // Коэффициент изменения радиуса вылета следующий пузырей
var n = 4; 
var maxStep = 5;        // Глубина деления

function clear()
{
  ctx.fillStyle = "black";
  ctx.fillRect(0,0,ctx.canvas.width, ctx.canvas.height);
}

class shape
{
  x; y; angle; r; speed; start_x; start_y; k; dAngle = 90; step = 0;
  isMain = false;
  constructor(x, y, angle, r, speed, k, step)
  {
    this.start_x = x; this.start_y = y;
    this.x = x; this.y = y;
    this.angle = angle; this.r = r;
    this.speed = speed; this.k = k;
    this.step = step;
  }
  update(time)
  {
    this.x += this.speed * time * Math.cos(this.angle*Math.PI/180);
    this.y += this.speed * time * Math.sin(this.angle*Math.PI/180);
  }
  getSquareDistFromStart()
  {
    return (this.x-this.start_x)*(this.x-this.start_x)+(this.y-this.start_y)*(this.y-this.start_y);
  }
  isOutOfRange()
  {
  if (this.x > ctx.canvas.width + this.r || this.x < this.r*(-1) || this.y > ctx.canvas.height + this.y || this.y < this.r*(-1)) return true;
  else return false;
  }
  mainProperty(x)
  {
    this.isMain = x;
  }
}

var objs = [];

function step()
{
  var endTime = Date.now();
  var time = (startTime - endTime) / 1000;
  draw();
  update(time);
  requestAnimationFrame(step);

  startTime = endTime;
}

function update(time)
{
  var l = objs.length;
  if (l == 0) { objs.push(new shape(startX, startY, startAngle, startR, startSpeed, kAngle, 0)); objs[0].mainProperty(true); }
  for(let i = 0; i < objs.length; i++)
  {
    objs[i].update(time);
    
    if (objs[i].isMain && objs[i].getSquareDistFromStart() >= (2*startR + 5)*(2*startR+5)) { objs.push(new shape(startX, startY, startAngle, startR, startSpeed, kAngle, 0)); objs[objs.length-1].mainProperty(true); objs[i].mainProperty(false); }
    
    if (objs[i].isOutOfRange() || objs[i].step > maxStep) { objs.splice(i,1); continue; }
    if (objs[i].getSquareDistFromStart() >= n*n*4*objs[i].r*objs[i].r)
    {
      objs.push(new shape(objs[i].x, objs[i].y, objs[i].angle, objs[i].r*kChange, objs[i].speed, objs[i].k, objs[i].step+1));
       objs.push(new shape(objs[i].x, objs[i].y, objs[i].angle + objs[i].dAngle*objs[i].k, objs[i].r*kChange, objs[i].speed, objs[i].k, objs[i].step+1));
       objs.push(new shape(objs[i].x, objs[i].y, objs[i].angle - objs[i].dAngle*objs[i].k, objs[i].r*kChange, objs[i].speed, objs[i].k, objs[i].step+1));
      objs.splice(i,1);
    }
  }
}

function draw()
{
  clear();
  ctx.fillStyle = "white";
  var l = objs.length;
  for(let i = 0; i < l; i++)
  {
    ctx.beginPath();
    ctx.arc(objs[i].x, objs[i].y, objs[i].r, 0, 2*Math.PI);
    ctx.closePath();
    ctx.stroke();
  }
}

var startTime = Date.now();
step();
